// ExtClockShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExtClockShape.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CExtClockShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CExtClockShape, CFODrawShape, 0)
CExtClockShape::CExtClockShape()
{
	SetType(MY_CLOCK_SHAPE); // you must asign your own ID here.
	SetPolyObject(FALSE);
	SetRotateProtect(TRUE);
	SetNullPen(FALSE);
	SetLineWidth(3);
	m_nTimerID				= -1;
	dMin = (double)COleDateTime::GetCurrentTime().GetMinute();
	dHour = (double)COleDateTime::GetCurrentTime().GetHour();
	dSecond = (double)COleDateTime::GetCurrentTime().GetSecond();
}

CExtClockShape::CExtClockShape(const CExtClockShape& src)
{
	m_nTimerID				= -1;

	dMin			= (double)COleDateTime::GetCurrentTime().GetMinute();
	dHour			= (double)COleDateTime::GetCurrentTime().GetHour();
	dSecond			= (double)COleDateTime::GetCurrentTime().GetSecond();
	*this = src;
}

CExtClockShape::~CExtClockShape()
{
	if( m_nTimerID !=  -1 )
	{
		UnregisterTimerEvent( m_nTimerID );
		m_nTimerID = -1;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CExtClockShape diagnostics

#ifdef _DEBUG
void CExtClockShape::AssertValid() const
{
	CFODrawShape::AssertValid();
}

void CExtClockShape::Dump(CDumpContext& dc) const
{
	CFODrawShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CExtClockShape::Create(CRect &rcPos,CString strCaption)
{

	AllocMemory(4);
	
	m_lpShapePoints[0] = CPoint(rcPos.left,  rcPos.top);
	m_lpShapePoints[1] = CPoint(rcPos.right, rcPos.top);
	m_lpShapePoints[2] = CPoint(rcPos.right, rcPos.bottom);
	m_lpShapePoints[3] = CPoint(rcPos.left,  rcPos.bottom);


	CFODrawShape::Create(rcPos,strCaption);
	
	//FODO:Add your own code here.

}

void CExtClockShape::Serialize(CArchive& ar)
{
	CFODrawShape::Serialize(ar);
	if(ar.IsStoring())
	{
		//FODO:Add your own code here.

	}
	else
	{
		//FODO:Add your own code here.

		dMin = (double)COleDateTime::GetCurrentTime().GetMinute();
		dHour = (double)COleDateTime::GetCurrentTime().GetHour();
		dSecond = (double)COleDateTime::GetCurrentTime().GetSecond();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CExtClockShape::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
								 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CExtClockShape::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CExtClockShape::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CExtClockShape::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}

CExtClockShape& CExtClockShape::operator=(const CExtClockShape& src)
{
	(*(CFODrawShape*)this) = src;
	return (*this);
}

CFODrawShape* CExtClockShape::Copy() const
{
	return (new CExtClockShape(*this));
}

void CExtClockShape::CalcExtendBoundRect(CRect &rcBound) const
{
	CFODrawShape::CalcExtendBoundRect(rcBound);
}

// Get default move handle position.
void CExtClockShape::GetNormalSpotLocation(CFOPHandleList& lstHandle)
{
	CFODrawShape::GetNormalSpotLocation(lstHandle);
}

void CExtClockShape::GetPlusSpotLocation(CFOPHandleList& lstHandle)
{
}

CRect CExtClockShape::CalcLabelPosition(CDC *pDC,BOOL &bFullSize) const
{
	pDC;
	CRect rcPos = GetSnapRect();
	rcPos.NormalizeRect();
	bFullSize = TRUE;
	return rcPos;
}

int	CExtClockShape::GetRotateAngle() const
{
	return CFODrawShape::GetRotateAngle();
}

BOOL CExtClockShape::GetRotateSpotLocation(CPoint &ptHandle)
{
	return CFODrawShape::GetRotateSpotLocation(ptHandle);
}

int CExtClockShape::GetNormalSpotCount() const
{
	return CFODrawShape::GetNormalSpotCount();
}

int CExtClockShape::GetPlusSpotCount() const
{
	return 0;
}

void CExtClockShape::GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const
{
	CFODrawShape::GetPathSimplePolygon(rPoly);

}

void CExtClockShape::PrepareDC(CDC* pDC)
{
	CFODrawShape::PrepareDC(pDC);

	//FODO:Add your own code below.
	
}

void CExtClockShape::OnDrawTrackCustom(CDC *pDC)
{
	CFODrawShape::OnDrawTrackCustom(pDC);

	// Add your own code here.

}

CString CExtClockShape::GenEditingLabel()
{
	CString strLabel = GetObjectCaption();
	return strLabel;
}

void CExtClockShape::OnDrawShadow(CDC *pDC)
{
	CFODrawShape::OnDrawShadow(pDC);
	
	//FODO:Add your own code below.
	
}
void CExtClockShape::DoDrawVisioOrderLine(CDC *pDC)
{
	CFODrawShape::DoDrawVisioOrderLine(pDC);

	//FODO:Add your own code below.
	
}


void CExtClockShape::OnDrawFlat(CDC *pDC)
{
	CFODrawShape::OnDrawFlat(pDC);

	//FODO:Add your own code below.
	DoStartTimer();

	FOPRect rc = GetDrawRect();

	FOPPoint ptCenter = rc.CenterPoint();

	double radius = min(rc.Width()/2.0,rc.Height()/2.0);
	
	FOPPoint ptHour, ptMin, ptSecond;

	Gen_Hour_Handle(&ptCenter,dHour,
               0.50 * radius, &ptHour);

    Gen_Min_Handle(&ptCenter,dMin,
                 0.80 * radius, &ptMin);

    Gen_Min_Handle(&ptCenter,dSecond,
                 0.85 * radius, &ptSecond);

	FOPRect rcEllipse(ptCenter.x - (int)radius, ptCenter.y - (int)radius, ptCenter.x + (int)radius, ptCenter.y + (int)radius);
	pDC->Ellipse(&rcEllipse);

	FOPPoint out, in;
    unsigned i;
    
	CPen pen1(PS_SOLID, 3, RGB(255,0,0));
	CPen *pOldPen1 = (CPen *)pDC->SelectObject(&pen1);

    for (i = 0; i < 12; ++i)
	{      
      double ticklen;
      switch(i)
	  {
          case 0:
            ticklen = 3.5 * 3; break;
          case 3: case 6: case 9:
            ticklen = 3 * 3; break;
          default:
            ticklen = 2 * 3; break;
      }

      Gen_Hour_Handle(&ptCenter, i,
                 radius, &out);

      Gen_Hour_Handle(&ptCenter, i,
                 radius-ticklen, &in);

	  pDC->MoveTo(out);
	  pDC->LineTo(in);
    }

	pDC->SelectObject(pOldPen1);
	pen1.DeleteObject();

	CPen pen(PS_SOLID, 3, RGB(0,0,255));
	CPen *pOldPen = (CPen *)pDC->SelectObject(&pen);

	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptHour);
	
	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptMin);
	
	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptSecond);

	pDC->SelectObject(pOldPen);
	pen.DeleteObject();
	
	radius = 3 * 2.25;
	rcEllipse = FOPRect(ptCenter.x - (int)radius, ptCenter.y - (int)radius, ptCenter.x + (int)radius, ptCenter.y + (int)radius);
	pDC->Ellipse(&rcEllipse);
}

void CExtClockShape::Gen_Angle(const FOPPoint *centre, double degrees, double radius,
							   FOPPoint *pt)
{
	double radians = ((90 - degrees) * F_PI) / 180.0;
	pt->x = CFODrawHelper::RoundValue(centre->x + radius * cos( radians ));
	pt->y = CFODrawHelper::RoundValue(centre->y - radius * sin( radians ));
}

void CExtClockShape::Gen_Hour_Handle(const FOPPoint *centre, double hours, double radius,
									 FOPPoint *pt)
{
	while (hours > 11) hours -= 12;
	
	Gen_Angle(centre,((double)hours) * 360.0 / 12.0,radius,pt);
}

void CExtClockShape::Gen_Min_Handle(const FOPPoint *centre, double minutes,
									double radius, FOPPoint *pt)
{
	Gen_Angle(centre,((double)minutes) * 360.0 / 60.0,radius,pt);
}

void CExtClockShape::OnDraw3d(CDC *pDC)
{
	CFODrawShape::OnDraw3d(pDC);

	//FODO:Add your own code below.

	DoStartTimer();

	FOPRect rc = GetDrawRect();

	FOPPoint ptCenter = rc.CenterPoint();

	double radius = min(rc.Width()/2.0,rc.Height()/2.0);
	
	FOPPoint ptHour, ptMin, ptSecond;

	Gen_Hour_Handle(&ptCenter,dHour,
               0.50 * radius, &ptHour);

    Gen_Min_Handle(&ptCenter,dMin,
                 0.80 * radius, &ptMin);

    Gen_Min_Handle(&ptCenter,dSecond,
                 0.85 * radius, &ptSecond);

	FOPRect rcEllipse(ptCenter.x - (int)radius, ptCenter.y - (int)radius, ptCenter.x + (int)radius, ptCenter.y + (int)radius);
	pDC->Ellipse(&rcEllipse);

	FOPPoint out, in;
    unsigned i;
    
	CPen pen1(PS_SOLID, 3, RGB(255,0,0));
	CPen *pOldPen1 = (CPen *)pDC->SelectObject(&pen1);

    for (i = 0; i < 12; ++i)
	{      
      double ticklen;
      switch(i)
	  {
          case 0:
            ticklen = 3.5 * 3; break;
          case 3: case 6: case 9:
            ticklen = 3 * 3; break;
          default:
            ticklen = 2 * 3; break;
      }

      Gen_Hour_Handle(&ptCenter, i,
                 radius, &out);

      Gen_Hour_Handle(&ptCenter, i,
                 radius-ticklen, &in);

	  pDC->MoveTo(out);
	  pDC->LineTo(in);
    }

	pDC->SelectObject(pOldPen1);
	pen1.DeleteObject();

	CPen pen(PS_SOLID, 3, RGB(0,0,255));
	CPen *pOldPen = (CPen *)pDC->SelectObject(&pen);

	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptHour);
	
	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptMin);
	
	pDC->MoveTo(ptCenter);
	pDC->LineTo(ptSecond);

	pDC->SelectObject(pOldPen);
	pen.DeleteObject();
	
	radius = 3 * 2.25;
	rcEllipse = FOPRect(ptCenter.x - (int)radius, ptCenter.y - (int)radius, ptCenter.x + (int)radius, ptCenter.y + (int)radius);
	pDC->Ellipse(&rcEllipse);
	
}

void CExtClockShape::ClearDC(CDC* pDC)
{
	CFODrawShape::ClearDC(pDC);

	//FODO:Add your own code below.

}

void CExtClockShape::GeometryUpdated(CFOArea* pArea)
{
	if (m_lpShapePoints && pArea)
	{
		pArea->BuildPolygonArea(m_lpShapePoints, m_nCompPtCount);

		m_rectPosition = pArea->GetBoundingRect();
	}
}

void CExtClockShape::SetParentWnd(CFOPCanvasCore *pWnd)
{
	if(pWnd == NULL && m_pParent != NULL)
	{
		if( m_nTimerID !=  -1 )
		{
			UnregisterTimerEvent( m_nTimerID );
			m_nTimerID = -1;
		}
	}

	m_pParent = pWnd; 
}

BOOL CExtClockShape::PositionCorrect()
{
	CRect rcSnap = GetDrawRect();
	rcSnap.DeflateRect(1,1,1,1);
	if(rcSnap.Height() < 20 || rcSnap.Width() < 20)
	{
		return FALSE;
	}

	return TRUE;
}

void CExtClockShape::DoStartTimer()
{
	BOOL bDesign = GetModel()->IsDesignMode();
	if(!bDesign)
	{
		if( m_nTimerID > 0)
		{
			if(!PositionCorrect())
			{
				UnregisterTimerEvent( m_nTimerID );
				m_nTimerID = -1;
			}
			return;
		}
		
		if(PositionCorrect())
		{
			m_nTimerID = RegisterTimerEvent( this, 500 );
		}
	}

	if(bDesign)
	{
		if( m_nTimerID !=  -1 )
		{
			UnregisterTimerEvent( m_nTimerID );
			m_nTimerID = -1;
	//		GetIndicator()->SetValue(0.0);
			UpdateControl() ;
		}
	}
}

void CExtClockShape::OnTimer( int nTimerID )
{
	if( nTimerID == m_nTimerID )
	{	
		dMin = (double)COleDateTime::GetCurrentTime().GetMinute();
		dHour = (double)COleDateTime::GetCurrentTime().GetHour();
		dSecond = (double)COleDateTime::GetCurrentTime().GetSecond();
		
		UpdateControl() ;
	}
	else
	{
		CFODrawShape::OnTimer( nTimerID );
	}
}
